#include <htc.h>
#include "user_define.h"
#include "wait_time.h"

extern	unsigned char	freq_byte1;
extern	unsigned char	freq_byte2;
extern	unsigned char	freq_byte3;
extern	unsigned char	freq_byte4;

/*---------- CPLD ----------*/
void	cpld_freq_in(void)
{
unsigned char	cpld_d0;
unsigned char	cpld_d1;
unsigned char	cpld_d2;
unsigned char	cpld_d3;
unsigned char	cpld_d4;
unsigned char	cpld_d5;
unsigned char	cpld_d6;
unsigned char	cpld_d7;

	FREQ_LATCH=1;NOP();
	wait_time(10);

	FREQ_SEL0=1;NOP();
	FREQ_SEL1=0;NOP();
	FREQ_SEL2=0;NOP();
	wait_time(10);
	cpld_d0=RA0;NOP();
	cpld_d1=RA1;NOP();
	cpld_d2=RA2;NOP();
	cpld_d3=RA3;NOP();
	cpld_d4=RA4;NOP();
	cpld_d5=RA5;NOP();
	cpld_d6=RA6;NOP();
	cpld_d7=RA7;NOP();

	freq_byte1=cpld_d0+cpld_d1*2+cpld_d2*4+cpld_d3*8+cpld_d4*16+cpld_d5*32+cpld_d6*64+cpld_d7*128;

	FREQ_SEL0=0;NOP();
	FREQ_SEL1=1;NOP();
	FREQ_SEL2=0;NOP();
	wait_time(10);	
	cpld_d0=RA0;NOP();
	cpld_d1=RA1;NOP();
	cpld_d2=RA2;NOP();
	cpld_d3=RA3;NOP();
	cpld_d4=RA4;NOP();
	cpld_d5=RA5;NOP();
	cpld_d6=RA6;NOP();
	cpld_d7=RA7;NOP();

	freq_byte2=cpld_d0+cpld_d1*2+cpld_d2*4+cpld_d3*8+cpld_d4*16+cpld_d5*32+cpld_d6*64+cpld_d7*128;

	FREQ_SEL0=1;NOP();
	FREQ_SEL1=1;NOP();
	FREQ_SEL2=0;NOP();
	wait_time(10);
	cpld_d0=RA0;NOP();
	cpld_d1=RA1;NOP();
	cpld_d2=RA2;NOP();
	cpld_d3=RA3;NOP();
	cpld_d4=RA4;NOP();
	cpld_d5=RA5;NOP();
	cpld_d6=RA6;NOP();
	cpld_d7=RA7;NOP();

	freq_byte3=cpld_d0+cpld_d1*2+cpld_d2*4+cpld_d3*8+cpld_d4*16+cpld_d5*32+cpld_d6*64+cpld_d7*128;

	FREQ_SEL0=0;NOP();
	FREQ_SEL1=0;NOP();
	FREQ_SEL2=1;NOP();
	wait_time(10);
	cpld_d0=RA0;NOP();
	cpld_d1=RA1;NOP();
	cpld_d2=RA2;NOP();
	cpld_d3=RA3;NOP();
	cpld_d4=RA4;NOP();
	cpld_d5=RA5;NOP();
	cpld_d6=RA6;NOP();
	cpld_d7=RA7;NOP();

	freq_byte4=cpld_d0+cpld_d1*2+cpld_d2*4+cpld_d3*8+cpld_d4*16+cpld_d5*32+cpld_d6*64+cpld_d7*128;

	FREQ_LATCH=0;NOP();	
	
}

void	cpld_set(unsigned char mode,unsigned char fl)
{
	switch(mode){
		case 0:	RC1=0;NOP();break;
		case 1:	RC1=1;NOP();break;
	}
	switch(fl){
		case 0:	RC2=0;NOP();break;
		case 1:	RC2=1;NOP();break;
	}
} 